searchNodes=[{"doc":"Module for making and processing AWS requests.","ref":"ExAws.html","title":"ExAws","type":"module"},{"doc":"Perform an AWS request. First build an operation from one of the services, and then pass it to this function to perform it. If you want to build an operation manually, see: ExAws.Operation This function takes an optional second parameter of configuration overrides. This is useful if you want to have certain configuration changed on a per request basis. Also you can configure telemetry metrics with: :telemetry_event - The telemetry event name to dispatch the event under. Defaults to [:ex_aws, :request] . :telemetry_options - Extra options to attach to telemetry event name. Examples If you have one of the service modules installed, you can just use those service modules like this: ExAws.S3 . list_buckets |&gt; ExAws . request ExAws.S3 . list_buckets |&gt; ExAws . request ( region : &quot;eu-west-1&quot; ) ExAws.Dynamo . get_object ( &quot;users&quot; , &quot;foo@bar.com&quot; ) |&gt; ExAws . request Alternatively you can create operation structs manually for services that aren't supported: op = % ExAws.Operation.JSON { http_method : :post , service : :dynamodb , headers : [ { &quot;x-amz-target&quot; , &quot;DynamoDB_20120810.ListTables&quot; } , { &quot;content-type&quot; , &quot;application/x-amz-json-1.0&quot; } ] , } ExAws . request ( op ) Telemetry events The following events are published: [:ex_aws, :request, :start] - dispatched on start every request sent to the AWS. [:ex_aws, :request, :stop] - dispatched on every response from AWS. [:ex_aws, :request, :exception] - dispatched after exceptions on request sent to AWS. With :metadata map including the following fields: :result - the request result: :ok or :error :attempt - the attempt number :service - the AWS service :options - extra options given to the repo operation under :telemetry_options","ref":"ExAws.html#request/2","title":"ExAws.request/2","type":"function"},{"doc":"Perform an AWS request, raise if it fails. Same as request/1,2 except it will either return the successful response from AWS or raise an exception.","ref":"ExAws.html#request!/2","title":"ExAws.request!/2","type":"function"},{"doc":"Return a stream for the AWS resource. Examples ExAws.S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . stream!","ref":"ExAws.html#stream!/2","title":"ExAws.stream!/2","type":"function"},{"doc":"A behaviour definition for the core operations of ExAws. ExAws implements this behaviour.","ref":"ExAws.Behaviour.html","title":"ExAws.Behaviour","type":"behaviour"},{"doc":"See ExAws.request/2 .","ref":"ExAws.Behaviour.html#c:request/1","title":"ExAws.Behaviour.request/1","type":"callback"},{"doc":"See ExAws.request/2 .","ref":"ExAws.Behaviour.html#c:request/2","title":"ExAws.Behaviour.request/2","type":"callback"},{"doc":"See ExAws.request!/2 .","ref":"ExAws.Behaviour.html#c:request!/1","title":"ExAws.Behaviour.request!/1","type":"callback"},{"doc":"See ExAws.request!/2 .","ref":"ExAws.Behaviour.html#c:request!/2","title":"ExAws.Behaviour.request!/2","type":"callback"},{"doc":"See ExAws.stream!/2 .","ref":"ExAws.Behaviour.html#c:stream!/1","title":"ExAws.Behaviour.stream!/1","type":"callback"},{"doc":"See ExAws.stream!/2 .","ref":"ExAws.Behaviour.html#c:stream!/2","title":"ExAws.Behaviour.stream!/2","type":"callback"},{"doc":"Generates the configuration for a service. It starts with the defaults for a given environment and then merges in the common config from the ex_aws config root, and then finally any config specified for the particular service. Refreshable fields Some fields are marked as refreshable. These fields will be fetched through the auth cache even if they are passed in as overrides. This is so stale credentials aren't used, for example, with long running streams. You can opt out of this behavior by passing refreshable: false when building a config with new/2 .","ref":"ExAws.Config.html","title":"ExAws.Config","type":"module"},{"doc":"","ref":"ExAws.Config.html#awscli_auth_adapter/0","title":"ExAws.Config.awscli_auth_adapter/0","type":"function"},{"doc":"","ref":"ExAws.Config.html#awscli_auth_credentials/2","title":"ExAws.Config.awscli_auth_credentials/2","type":"function"},{"doc":"","ref":"ExAws.Config.html#build_base/2","title":"ExAws.Config.build_base/2","type":"function"},{"doc":"Builds a minimal HTTP configuration.","ref":"ExAws.Config.html#http_config/2","title":"ExAws.Config.http_config/2","type":"function"},{"doc":"Builds a complete set of config for an operation. Defaults are pulled from ExAws.Config.Defaults Common values set via e.g config :ex_aws are merged in. Keys set on the individual service e.g config :ex_aws, :s3 are merged in Finally, any configuration overrides are merged in","ref":"ExAws.Config.html#new/2","title":"ExAws.Config.new/2","type":"function"},{"doc":"","ref":"ExAws.Config.html#parse_host_for_region/1","title":"ExAws.Config.parse_host_for_region/1","type":"function"},{"doc":"","ref":"ExAws.Config.html#retrieve_runtime_config/1","title":"ExAws.Config.retrieve_runtime_config/1","type":"function"},{"doc":"","ref":"ExAws.Config.html#retrieve_runtime_value/2","title":"ExAws.Config.retrieve_runtime_value/2","type":"function"},{"doc":"","ref":"ExAws.Config.html#t:t/0","title":"ExAws.Config.t/0","type":"type"},{"doc":"Defaults for each service","ref":"ExAws.Config.Defaults.html","title":"ExAws.Config.Defaults","type":"module"},{"doc":"","ref":"ExAws.Config.Defaults.html#apply_defaults/4","title":"ExAws.Config.Defaults.apply_defaults/4","type":"function"},{"doc":"Retrieve the default configuration for a service.","ref":"ExAws.Config.Defaults.html#defaults/1","title":"ExAws.Config.Defaults.defaults/1","type":"function"},{"doc":"","ref":"ExAws.Config.Defaults.html#get/2","title":"ExAws.Config.Defaults.get/2","type":"function"},{"doc":"","ref":"ExAws.Config.Defaults.html#host/2","title":"ExAws.Config.Defaults.host/2","type":"function"},{"doc":"Specifies expected behaviour of a credentials provider. A credentials initializer provider is a module that fetches the AWS credentials from different sources.","ref":"ExAws.CredentialsIni.Provider.html","title":"ExAws.CredentialsIni.Provider","type":"behaviour"},{"doc":"","ref":"ExAws.CredentialsIni.Provider.html#c:security_credentials/1","title":"ExAws.CredentialsIni.Provider.security_credentials/1","type":"callback"},{"doc":"","ref":"ExAws.CredentialsIni.Provider.html#t:credentials/0","title":"ExAws.CredentialsIni.Provider.credentials/0","type":"type"},{"doc":"","ref":"ExAws.CredentialsIni.Provider.html#t:profile/0","title":"ExAws.CredentialsIni.Provider.profile/0","type":"type"},{"doc":"For use with IMDSv2, this module retrieves the metadata session token and refreshes it before expiration.","ref":"ExAws.InstanceMetaTokenProvider.html","title":"ExAws.InstanceMetaTokenProvider","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExAws.InstanceMetaTokenProvider.html#child_spec/1","title":"ExAws.InstanceMetaTokenProvider.child_spec/1","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#get/1","title":"ExAws.InstanceMetaTokenProvider.get/1","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#get_headers/1","title":"ExAws.InstanceMetaTokenProvider.get_headers/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ExAws.InstanceMetaTokenProvider.html#init/1","title":"ExAws.InstanceMetaTokenProvider.init/1","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#refresh_in/1","title":"ExAws.InstanceMetaTokenProvider.refresh_in/1","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#refresh_token/2","title":"ExAws.InstanceMetaTokenProvider.refresh_token/2","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#request_token/1","title":"ExAws.InstanceMetaTokenProvider.request_token/1","type":"function"},{"doc":"","ref":"ExAws.InstanceMetaTokenProvider.html#start_link/1","title":"ExAws.InstanceMetaTokenProvider.start_link/1","type":"function"},{"doc":"Defines the specification for a JSON codec. ExAws supports the use of your favorite JSON codec provided it fulfills this specification. Poison fulfills this spec without modification, and is the default. See the contents of ExAws.JSON.JSX for an example of an alternative implementation. Example Here for example is the code required to make jsx comply with this spec. In your config you would do: config :ex_aws , json_codec : ExAws.JSON.JSX defmodule ExAws.JSON.JSX do @behaviour ExAws.JSON.Codec @moduledoc false def encode! ( %{ } = map ) do map |&gt; :jsx . encode end def encode ( map ) do try do { :ok , encode! ( map ) } rescue ArgumentError -&gt; { :error , :badarg } end end def decode! ( string ) do :jsx . decode ( string , [ :return_maps ] ) end def decode ( string ) do try do { :ok , decode! ( string ) } rescue ArgumentError -&gt; { :error , :badarg } end end end","ref":"ExAws.JSON.Codec.html","title":"ExAws.JSON.Codec","type":"behaviour"},{"doc":"","ref":"ExAws.JSON.Codec.html#c:decode/1","title":"ExAws.JSON.Codec.decode/1","type":"callback"},{"doc":"","ref":"ExAws.JSON.Codec.html#c:decode!/1","title":"ExAws.JSON.Codec.decode!/1","type":"callback"},{"doc":"","ref":"ExAws.JSON.Codec.html#c:encode/1","title":"ExAws.JSON.Codec.encode/1","type":"callback"},{"doc":"","ref":"ExAws.JSON.Codec.html#c:encode!/1","title":"ExAws.JSON.Codec.encode!/1","type":"callback"},{"doc":"An operation to perform on AWS. This module defines a protocol for executing operations on AWS. ExAws ships with several different modules that each implement the ExAws.Operation protocol. These modules each handle one of the broad categories of AWS service types: ExAws.Operation.JSON ExAws.Operation.Query ExAws.Operation.RestQuery ExAws.Operation.S3 ExAws works by creating a data structure that implements this protocol, and then calling perform/2 on it.","ref":"ExAws.Operation.html","title":"ExAws.Operation","type":"protocol"},{"doc":"Perform a request on AWS. The operation is synchronous, returning a response or an error. Example % ExAws.Operation.JSON { data : %{ } , headers : [ { &quot;x-amz-target&quot; , &quot;DynamoDB_20120810.ListTables&quot; } , { &quot;content-type&quot; , &quot;application/x-amz-json-1.0&quot; } ] , http_method : :post , params : %{ } , path : &quot;/&quot; , service : :dynamodb , } |&gt; ExAws.Operation . perform ( ExAws.Config . new ( :dynamodb ) )","ref":"ExAws.Operation.html#perform/2","title":"ExAws.Operation.perform/2","type":"function"},{"doc":"Perform a streaming request on AWS.","ref":"ExAws.Operation.html#stream!/2","title":"ExAws.Operation.stream!/2","type":"function"},{"doc":"","ref":"ExAws.Operation.html#t:t/0","title":"ExAws.Operation.t/0","type":"type"},{"doc":"Datastructure representing an operation on a JSON based AWS service. This module is generally not used directly, but rather is constructed by one of the relevant AWS services. These include: DynamoDB Kinesis Lambda (Rest style) ElasticTranscoder JSON services are generally pretty simple. You just need to populate the data attribute with whatever request body parameters need converted to JSON, and set any service specific headers. The before_request","ref":"ExAws.Operation.JSON.html","title":"ExAws.Operation.JSON","type":"module"},{"doc":"","ref":"ExAws.Operation.JSON.html#new/2","title":"ExAws.Operation.JSON.new/2","type":"function"},{"doc":"","ref":"ExAws.Operation.JSON.html#t:t/0","title":"ExAws.Operation.JSON.t/0","type":"type"},{"doc":"Datastructure representing an operation on a Query based AWS service These include: SQS SNS SES","ref":"ExAws.Operation.Query.html","title":"ExAws.Operation.Query","type":"module"},{"doc":"","ref":"ExAws.Operation.Query.html#t:t/0","title":"ExAws.Operation.Query.t/0","type":"type"},{"doc":"Holds data necessary for an operation on the S3 service.","ref":"ExAws.Operation.S3.html","title":"ExAws.Operation.S3","type":"module"},{"doc":"","ref":"ExAws.Operation.S3.html#t:t/0","title":"ExAws.Operation.S3.t/0","type":"type"},{"doc":"Configuration for :hackney . Options can be set for :hackney with the following config: config :ex_aws , :hackney_opts , recv_timeout : 30_000 The default config handles setting the above.","ref":"ExAws.Request.Hackney.html","title":"ExAws.Request.Hackney","type":"module"},{"doc":"Callback implementation for ExAws.Request.HttpClient.request/5 .","ref":"ExAws.Request.Hackney.html#request/5","title":"ExAws.Request.Hackney.request/5","type":"function"},{"doc":"Specifies expected behaviour of an HTTP client. ExAws allows you to use your HTTP client of choice, provided that it can be coerced into complying with this module's specification. The default is :hackney . Example Here for example is the code required to make HTTPotion comply with this spec. In your config you would do: config :ex_aws , http_client : ExAws.Request.HTTPotion defmodule ExAws.Request.HTTPotion do @behaviour ExAws.Request.HttpClient def request ( method , url , body , headers , _http_opts ) do case HTTPotion . request ( method , url , body : body , headers : headers , ibrowse : [ headers_as_is : true ] ) do % HTTPotion.Response { } = response -&gt; { :ok , response } % HTTPotion.ErrorResponse { } = error -&gt; { :error , %{ reason : error } } end end end When conforming your selected HTTP Client take note of a few things: The module name doesn't need to follow the same styling as this module it is simply your own 'HTTP Client', i.e. MyApp.HttpClient The request function must accept the methods as described in the request/5 callback, you can however set these as optional, i.e. http_opts \\ [] Ensure the call to your chosen HTTP Client is correct and the return is in the same format as defined in the request/5 callback Example def request ( method , url , body , headers , http_opts \\ [ ] ) do Mojito . request ( method , url , headers , body , http_opts ) end","ref":"ExAws.Request.HttpClient.html","title":"ExAws.Request.HttpClient","type":"behaviour"},{"doc":"","ref":"ExAws.Request.HttpClient.html#c:request/5","title":"ExAws.Request.HttpClient.request/5","type":"callback"},{"doc":"","ref":"ExAws.Request.HttpClient.html#t:http_method/0","title":"ExAws.Request.HttpClient.http_method/0","type":"type"},{"doc":"A generic AWS error.","ref":"ExAws.Error.html","title":"ExAws.Error","type":"exception"},{"doc":"A flexible easy to use set of AWS APIs. Available Services: https://github.com/ex-aws?q=service&amp;type=&amp;language=","ref":"readme.html","title":"ExAws","type":"extras"},{"doc":"ExAws v2.0 breaks out every service into its own package. To use the S3 service, you need both the core :ex_aws package as well as the :ex_aws_s3 package. As with all ExAws services, you'll need a compatible HTTP client (defaults to :hackney ) and whatever JSON or XML codecs needed by the services you want to use. Consult individual service documentation for details on what each service needs. defp deps do [ { :ex_aws , &quot;~&gt; 2.1&quot; } , { :ex_aws_s3 , &quot;~&gt; 2.0&quot; } , { :hackney , &quot;~&gt; 1.9&quot; } , { :sweet_xml , &quot;~&gt; 0.6&quot; } , ] end With these deps you can use ExAws precisely as you're used to: # make a request (with the default region) ExAws.S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . request ( ) # or specify the region ExAws.S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . request ( region : &quot;us-west-1&quot; ) # some operations support streaming ExAws.S3 . list_objects ( &quot;my-bucket&quot; ) |&gt; ExAws . stream! ( ) |&gt; Enum . to_list ( ) AWS Key configuration ExAws requires valid AWS keys in order to work properly. ExAws by default does the equivalent of: config :ex_aws , access_key_id : [ { :system , &quot;AWS_ACCESS_KEY_ID&quot; } , :instance_role ] , secret_access_key : [ { :system , &quot;AWS_SECRET_ACCESS_KEY&quot; } , :instance_role ] This means it will try to resolve credentials in order: Look for the AWS standard AWS_ACCESS_KEY_ID and AWS_SECRET_ACCESS_KEY environment variables Resolve credentials with IAM If running inside ECS and a task role has been assigned it will use it Otherwise it will fall back to the instance role AWS CLI config files are supported, but require an additional dependency: { :configparser_ex , &quot;~&gt; 4.0&quot; } You can then add {:awscli, &quot;profile_name&quot;, timeout} to the above config and it will pull information from ~/.aws/config and ~/.aws/credentials Alternatively, if you already have a profile name set in the AWS_PROFILE environment variable, you can use that with {:awscli, :system, timeout} config :ex_aws , access_key_id : [ { :system , &quot;AWS_ACCESS_KEY_ID&quot; } , { :awscli , &quot;default&quot; , 30 } , :instance_role ] , secret_access_key : [ { :system , &quot;AWS_SECRET_ACCESS_KEY&quot; } , { :awscli , &quot;default&quot; , 30 } , :instance_role ] For role based authentication via role_arn and source_profile an additional dependency is required: { :ex_aws_sts , &quot;~&gt; 2.0&quot; } Further information on role based authentication is provided in said dependency. Session token configuration Alternatively, you can also provide AWS_SESSION_TOKEN to security_token to authenticate with session token: config :ex_aws , access_key_id : { :system , &quot;AWS_ACCESS_KEY_ID&quot; } , security_token : { :system , &quot;AWS_SESSION_TOKEN&quot; } , secret_access_key : { :system , &quot;AWS_SECRET_ACCESS_KEY&quot; } Hackney configuration ExAws by default uses hackney to make HTTP requests to AWS API. You can modify the options as such: config :ex_aws , :hackney_opts , follow_redirect : true , recv_timeout : 30_000 AWS Region Configuration. You can set the region used by default for requests. config :ex_aws , region : &quot;us-west-2&quot; , Alternatively, the region can be set in an environment variable: config :ex_aws , region : { :system , &quot;AWS_REGION&quot; } JSON Codec Configuration The default JSON codec is Jason. You can choose a different one: config :ex_aws , json_codec : Poison Path Normalization Paths that include multiple consecutive /'s will by default be normalized to a single slash. There are cases when paths need to be literal (S3) and this normalization behaviour can be turned off via configuration: config :ex_aws , normalize_path : false","ref":"readme.html#getting-started","title":"ExAws - Getting Started","type":"extras"},{"doc":"ExAws can also be used directly without any specific service module. You need to figure out how the API of the specific AWS service works, in particular: Protocol (JSON or query). Path (depends on the service and the specific operation, usually &quot;/&quot;). Service name (used to generate the request signature, as described here ). Request body, query params, HTTP method, and headers (depends on the service and specific operation). You can look for this information in the service's API reference at docs.aws.amazon.com or, for example, in the Go SDK API models at github.com/aws/aws-sdk-go (look for a api-*.json file). The protocol dictates which operation module to use for the request. If the protocol is JSON, use ExAws.Operation.JSON , if it's query, use ExAws.Operation.Query . Examples Redshift DescribeClusters action = :describe_clusters action_string = action |&gt; Atom . to_string |&gt; Macro . camelize operation = % ExAws.Operation.Query { path : &quot;/&quot; , params : %{ &quot;Action&quot; =&gt; action_string } , service : :redshift , action : action } ExAws . request ( operation ) ECS RunTask data = %{ taskDefinition : &quot;hello_world&quot; , launchType : &quot;FARGATE&quot; , networkConfiguration : %{ awsvpcConfiguration : %{ subnets : [ &quot;subnet-1a2b3c4d&quot; , &quot;subnet-4d3c2b1a&quot; ] , securityGroups : [ &quot;sg-1a2b3c4d&quot; ] , assignPublicIp : &quot;ENABLED&quot; } } } operation = % ExAws.Operation.JSON { http_method : :post , headers : [ { &quot;x-amz-target&quot; , &quot;AmazonEC2ContainerServiceV20141113.RunTask&quot; } , { &quot;content-type&quot; , &quot;application/x-amz-json-1.1&quot; } ] , path : &quot;/&quot; , data : data , service : :ecs } ExAws . request ( operation )","ref":"readme.html#direct-usage","title":"ExAws - Direct Usage","type":"extras"},{"doc":"Easy configuration. Minimal dependencies. Choose your favorite JSON codec and HTTP client. Elixir streams to automatically retrieve paginated resources. Elixir protocols allow easy customization of Dynamo encoding / decoding. Simple. ExAws aims to provide a clear and consistent elixir wrapping around AWS APIs, not abstract them away entirely. For every action in a given AWS API there is a corresponding function within the appropriate module. Higher level abstractions like the aforementioned streams are in addition to and not instead of basic API calls. That's it!","ref":"readme.html#highlighted-features","title":"ExAws - Highlighted Features","type":"extras"},{"doc":"ExAws will retry failed AWS API requests using exponential backoff per the &quot;Full Jitter&quot; formula described in https://www.awsarchitectureblog.com/2015/03/backoff.html The algorithm uses three values, which are configurable: # default values shown below config :ex_aws , :retries , max_attempts : 10 , base_backoff_in_ms : 10 , max_backoff_in_ms : 10_000 max_attempts is the maximum number of possible attempts with backoffs in between each one base_backoff_in_ms corresponds to the base value described in the blog post max_backoff_in_ms corresponds to the cap value described in the blog post","ref":"readme.html#retries","title":"ExAws - Retries","type":"extras"},{"doc":"If you want to run mix test , you'll need to have a local dynamodb running on port 8000. See Setting up DynamoDB Local . The redirect test will intentionally cause a warning to be issued.","ref":"readme.html#testing","title":"ExAws - Testing","type":"extras"},{"doc":"The MIT License (MIT) Copyright (c) 2014-2020 CargoSense, Inc. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"ExAws - License","type":"extras"}]